function clu = init_clust()
%INIT_CLUST initialize an empty cluster structure
%   CLU = INIT_CLUST() initialize an empty structure CLU for execute the 
%   fds evolving algorithm
%
%   See also CLUST_EVOL, CLUST_TRAIN

%   Copyright 2013 Francesco Trovo' Politecnico di Milano
%   $Revision: 1.0$  $Date: 2013/04/04$

clu.samples = [];
clu.train_samples = clu.samples;
clu.raw_data.Y = [];
clu.raw_data.Z = [];

% Nominal state initialization
clu.points_nor = [];
clu.n_points_nor = [];
clu.time_nor= [];
clu.med_nor = [];
clu.vari_nor = [];
clu.n_clust_nor = 0;
clu.added_point_nor = cell(1,0);
clu.n_added_point_nor = [];
clu.added_time_nor = cell(1,0);

% Alternate state initialization
clu.points_fau = [];
clu.med_fau = [];
clu.vari_fau = [];
clu.time_fau = [];
clu.n_points_fau = [];
clu.n_clust_fau = 0;
clu.added_point_fau = cell(1,0);
clu.n_added_point_fau = [];
clu.added_time_fau = cell(1,0);
clu.cre_time = [];
clu.clust_ret = [];

% Outlier set initialization
clu.outliers = [];
clu.outliers_time = [];
clu.n_outl = 0;

%Storing the mean and variance
clu.mean = [];
clu.variance = [];
clu.n_points = 0;
clu.last_time_instant = 0;

clu.n_merge = 0;
