function [center index] = find_centers(clu,curr_time,opt_evo)

[n p] = size(clu.outliers);

% Radius calculation
if strcmp(opt_evo.rad_calc,'corr')
    opt_evo.r = calc_rad_corr(clu,curr_time,opt_evo);
elseif strcmp(opt_evo.rad_calc,'theo')
    opt_evo.r = calc_radius_norm(n,p,opt_evo);
elseif strcmp(opt_evo.rad_calc,'med')
    opt_evo.r = calc_rad_med(clu,curr_time,opt_evo);
end

data = normalize(clu,clu.outliers);
times = clu.outliers_time;
centers = data;
centers_time = times;
iter_diff = 2 * opt_evo.eta_i;
n_iter = 0;

% Maximization of the center potentials starting from each single parameter
% vector
while (n_iter < opt_evo.max_iter && iter_diff > opt_evo.eta_i)
    S = calc_poten(clu,centers,centers_time,curr_time,opt_evo);
    centers_old = centers;
    centers_time_old = centers_time;
    centers = zeros(size(centers));
    centers_time = zeros(size(centers_time));
    for i = 1:n
        for j = 1:n
            centers(i,:) = centers(i,:) + S(i,j) * data(j,:);
            centers_time(i) = centers_time(i) + S(i,j) * times(j);
        end
        centers(i,:) = centers(i,:) / sum(S(i,:));
        centers_time(i) = centers_time(i) / sum(S(i,:));
    end
    n_iter = n_iter + 1;
    iter_diff = 0;
    for i = 1:n
        iter_diff = max([iter_diff ...
            sqrt(my_norm(centers(i,:),centers_old(i,:),centers_time(i),centers_time_old(i),curr_time,opt_evo.w))...
            ]);
    end
end

clust{1} = centers(1,:);
clust_tem{1} = centers_time(1);
indexes{1} = 1;
n_points = 1;
n_clust = 1;
eps_dist = 2 * opt_evo.eta_i;

for i = 2:n
    for j = 1:n_clust
        incl = 0;
        k = 1;
        while ( incl == 0 && k <= size(clust{j},1) )
            if sqrt(my_norm(clust{j}(k,:),centers(i,:),clust_tem{j}(k),centers_time(i),curr_time,opt_evo.w)) < eps_dist
                incl = 1;
                clust{j} = [clust{j}; centers(i,:)];
                clust_tem{j} = [clust_tem{j}; centers_time(i)];
                indexes{j} = [indexes{j} i];
                n_points(j) = n_points(j) + 1;
            end
            k = k + 1;
        end
    end
    if incl ~= 1
        n_clust = n_clust + 1;
        clust{n_clust} = centers(i,:);
        clust_tem{n_clust} = centers_time(i);
        indexes{n_clust} = i;
        n_points(n_clust) = 1;
    end
end

centers = zeros(n_clust,size(data,2));
for i = 1:n_clust
    centers(i,:) = mean(clust{i});
end

% Choose the most numerous cluster
chosen_ind = find(n_points == max(n_points),1);
center = denormalize(clu,centers(chosen_ind,:));
index = indexes{chosen_ind};
