function data = montecarlo_gmm(cl,n_points,alpha_s)

centers = [ cl.med_nor cl.med_fau ];
covariance = [ cl.vari_nor cl.vari_fau ];
class_num = [(cl.n_points_nor+cl.n_added_point_nor) (cl.n_points_fau+cl.n_added_point_fau)];
class_prob = class_num / sum(class_num);

p = size(centers{1},2);
data = zeros(n_points,p);
 
for i = 1:n_points
    ind = find(cumsum(class_prob) > rand(1),1);
    n = class_num(ind);
    mahal = Inf;
    while mahal > (n^2-1) * p / n / (n-p) * finv(1-alpha_s,p,n-p)
        data(i,:) = mvnrnd(centers{ind},covariance{ind});
        mahal = mahalanobis(data(i,:),centers{ind},covariance{ind});
    end
end
