function H = multi_kstest(data1,data2,alpha,verbose)
% method considering a single cdf
assert(size(data1,2) == size(data2,2));

n1 = size(data1,1);
n2 = size(data2,1);

p = size(data1,2);

ks_stat = 0;

logic = fliplr(de2bi(p,p));
n_logic = 1-logic;

for k = 1:n1
    geq_est = data1(k*ones(1,n1),:) .*   logic(ones(1,n1),:) <  data1 .* logic(ones(1,n1),:);
    leq_est = data1(k*ones(1,n1),:) .* n_logic(ones(1,n1),:) >  data1 .* n_logic(ones(1,n1),:);
    est_dens = sum(sum(geq_est + leq_est,2) == p) / (n1 - 1);
    geq_rea = data1(k*ones(1,n2),:) .*   logic(ones(1,n2),:) <  data2 .* logic(ones(1,n2),:);
    leq_rea = data1(k*ones(1,n2),:) .* n_logic(ones(1,n2),:) >  data2 .* n_logic(ones(1,n2),:);
    rea_dens = sum(sum(geq_rea + leq_rea,2) == p) / (n2 - 1);
    ks_stat = max( [ ks_stat abs(est_dens - rea_dens)] );
end
for k = 1:n2
    geq_est = data2(k*ones(1,n2),:) .*   logic(ones(1,n2),:) <  data2 .* logic(ones(1,n2),:);
    leq_est = data2(k*ones(1,n2),:) .* n_logic(ones(1,n2),:) >  data2 .* n_logic(ones(1,n2),:);
    est_dens = sum(sum(geq_est + leq_est,2) == p) / (n2 - 1);
    geq_rea = data2(k*ones(1,n1),:) .*   logic(ones(1,n1),:) <  data1 .* logic(ones(1,n1),:);
    leq_rea = data2(k*ones(1,n1),:) .* n_logic(ones(1,n1),:) >  data1 .* n_logic(ones(1,n1),:);
    rea_dens = sum(sum(geq_rea + leq_rea,2) == p) / (n1 - 1);
    ks_stat = max( [ ks_stat abs(est_dens - rea_dens)] );
end

n = n1 * n2 /(n1 + n2);

%lambda = ks_stat * sqrt(n);

%Valid if n >= 5
lambda =  (sqrt(n) + 0.12 + 0.11/sqrt(n)) * ks_stat;

j       =  (1:101)';
pValue  =  2 * sum((-1).^(j-1).*exp(-2*lambda*lambda*(j.^2)));
pValue  =  min(max(pValue, 0), 1);
if verbose == 1
    fprintf('%s%f\n','KS pValue :',pValue);
end
H  =  (pValue < alpha);
