function r = calc_rad_corr(cl,curr_time,opt)

data = normalize(cl,cl.outliers);
time = cl.outliers_time;
n = size(data,1);

if n <= 3
    r = calc_rad_med(cl,curr_time,opt);
else
    opt.r = 0;
    med = mean(data,1);
    t_med = mean(time);
    for i = 1:n
        opt.r = opt.r + my_norm(data(i,:),med,time(i),t_med,curr_time,opt.w) / n;
    end
    opt.r = 1 / 2 * sqrt(opt.r);
    poten = calc_all_poten(cl,curr_time,opt);
    iter = 1;
    rho = opt.rho_zero;

    t_stat = ((1+rho) / (1-rho) * exp(2 * norminv(opt.alpha_rho,0,1) / sqrt(n-3)) - 1) ...
        / ((1+rho) / (1-rho) * exp(2 * norminv(opt.alpha_rho,0,1) / sqrt(n-3)) + 1);

    corr = (t_stat - 1) * ones(2);

    % Find proper radius which is higly correlated with the following
    while(corr(2,1) < t_stat )
        r_old = opt.r;
        opt.r = opt.r * iter / (iter + 1);
        poten_old = poten;
        poten = calc_all_poten(cl,curr_time,opt);
        corr = corrcoef(poten,poten_old);
    end
    r = r_old;
end