function res = calc_errors(clu,model,labels,opt_evo)

test_labels = labels(opt_evo.n_train_batch+1:end);

addpath(strcat('.',filesep,'comparison'));

% Classification for FDS
class_FDS = class_fds(clu);
class_FDS = class_FDS(opt_evo.n_train_batch+1:end);
err_FDS = class_comp(class_FDS,test_labels);
p_outl_FDS = sum(class_FDS == 0) / opt_evo.n_test_batch;

data_DB = zscore(model.res_fau');
min_clust = size(clu.samples,2)+1; %as in our method we require p+1 parameter vectors
[class_DB, ~] = dbscan(data_DB,min_clust,[]);
class_DB = class_DB(opt_evo.n_train_batch+1:end);
err_DBscan = class_comp(class_DB,test_labels);
p_outl_DBscan = sum(class_DB == -1) / length(class_DB);

data_AP = model.res_fau';
class_AP = apclust(data_AP);
class_AP = class_AP(opt_evo.n_train_batch+1:end);
p_outl_AP = 0;
err_AP = class_comp(class_AP,test_labels);

data_ECM = zscore(model.res_fau');
class_ECM = ECM(data_ECM',0.1); %as in their paper
class_ECM = class_ECM(opt_evo.n_train_batch+1:end);
err_ECM = class_comp(class_ECM,test_labels);
p_outl_ECM = 0;

res.class_FDS = 1 - err_FDS;
res.class_ECM = 1 - err_ECM;
res.class_DBscan = 1 - err_DBscan;
res.class_AP = 1 - err_AP;

res.p_outl_FDS = p_outl_FDS;
res.p_outl_ECM = p_outl_ECM;
res.p_outl_DBscan = p_outl_DBscan;
res.p_outl_AP = p_outl_AP;

res.n_FDS = max(class_FDS);
res.n_ECM = max(class_ECM);
res.n_DB = max(class_DB);
res.n_AP = max(class_AP);

res.tau = mean(clu.clust_ret);

res.n_merge = clu.n_merge;
