function label = label_model(data_label,opt_est,opt_fau,perc)

n_train_batches = floor(opt_fau.not_fault / opt_est.eff_batch);
n_train_data = n_train_batches * opt_est.eff_batch;
n_test_batches = floor( (length(data_label) - n_train_data) / opt_est.eff_batch );

label = zeros(1,n_train_batches+n_test_batches);


for i = 1:n_train_batches
    idx_init = 1 + (i-1)* opt_est.eff_batch;
    idx_end = i * opt_est.eff_batch;
    temp = data_label(idx_init:idx_end);
    if sum(temp == mode(temp)) / opt_est.eff_batch >= perc
        label(i) = mode(temp);
    end
end

for i = (n_train_batches+1):(n_train_batches+n_test_batches)
    idx_init = 1 + (i-1)* opt_est.eff_batch;
    idx_end = i * opt_est.eff_batch;
    temp = data_label(idx_init:idx_end);
    if sum(temp == mode(temp)) / opt_est.eff_batch >= perc
        label(i) = mode(temp);
    end
end
