function [adj cor] = corr_graph(data,corr_thresh)

if size(data,2) > size(data,1)
    data = data';
end
if isempty(corr_thresh)
    corr_thresh = 0;
end

n_var = size(data,2);

% Crosscorrelation computation
cor = zeros(n_var);
lag = zeros(n_var);

% for ii = 1:n_var
%     cross_corr(ii,:) = xcorr(data(:,ii),10,'coeff');
% end

for jj = 1:n_var
    data1 = data(:,jj);
    for ii = 1:n_var
        if jj == ii
            cor(jj,ii) = 0;
            lag(jj,ii) = 0;
        else
            data2 = data(:,ii);
            [temp_corr, temp_lag] = xcorr((data1 - mean(data1))',(data2 - mean(data2))', 10, 'coeff'); %crosscorr(data1, data2)
            
            % Absolute value of the correlation is considered
            [max_corr, index] = max(abs(temp_corr));
            cor(jj,ii) = max_corr; %maximum correlation between jj an ii data
            lag(jj,ii) = temp_lag(index); %lag for which the correlation is maximum
            %prod_cor(jj,ii) = cross_corr(jj,lag(jj,ii)+11) * cross_corr(ii,lag(jj,ii)+11);
        end
    end
end

% Computing the adjency matrix
adj = zeros(n_var);
for i = 1:n_var
    for j = 1:n_var
        if (cor(i,j) >= corr_thresh) && lag(i,j) <= 0
            adj(i,j) = 1;
        end
    end
end
