function [H pval] = test_exog(theta,n_train,arx_order,const_input,alpha)

if isempty(alpha)
    alpha = 0.05;
end

n_rel = length(theta);

for i = 1:n_rel
    assert(size(theta{i},2) == arx_order(i,1) + arx_order(i,2)+const_input);
end

t_stat = zeros(n_rel,1);
mu = cell(n_rel,1);
sigma = cell(n_rel,1);
pval = zeros(n_rel,1);

for i = 1:n_rel
    p = arx_order(i,2) + const_input;
    regr_features = theta{i}(1:n_train,(arx_order(i,1)+1):end);
    mu{i} = mean(regr_features);
    sigma{i} = cov(regr_features);
    t_stat(i) = n_train * (n_train - p) / p / (n_train - 1) * mahalanobis(mu{i},zeros(1,p),sigma{i});
    pval(i) = 1 - fcdf(t_stat(i), p, n_train - p);
end
H = pval < alpha;
