function [tot_model] = cat_model(model1,model2)
% CAT_MODEL concatenates two models (or model arrays)
%
%   Input:
%       model1, model2: structures of type model (fields: res_fau, eps_fau,
%           residuals, Z and Y)
%
%   Output:
%       tot_model: concatenated model

tot_model.res_fau = [ model1.res_fau model2.res_fau ];
tot_model.eps_fau = [ model1.eps_fau model2.eps_fau ];
tot_model.residuals = [ model1.residuals model2.residuals ];

tot_model.Z = [ model1.Z model2.Z ];
tot_model.Y = [ model1.Y model2.Y ];
