function opt_est = ord_est(data,opt_data,opt_est)

if strcmp(opt_est.mode,'arx')
    if strcmp(opt_est.choose_order,'manual')
        opt_est.aord = 2;
        opt_est.bord = 1;
    elseif strcmp(opt_est.choose_order,'automatic')
        data = [data(:,2) data(:,1)];
        TrS_interval = [1 floor(opt_est.train_est_perc * opt_est.hor)];
        VaS_interval = [floor(opt_est.train_est_perc * opt_est.hor)+1 opt_est.hor];
        ordersRange = [1 opt_est.max_ord_expl 1 opt_est.max_ord_expl 0 0];
        [~, orderO, ~, ~] = IdArMa(data, TrS_interval, 'arx', ordersRange, 1, VaS_interval);
        opt_est.aord = orderO(1);
        opt_est.bord = orderO(2);
        %Old version (suppports also multi input arx models)
        %opt_est = arx_order_estimation(data,opt_data,opt_est);
    end

elseif strcmp(opt_est.mode,'rn')
    if strcmp(opt_est.choose_order,'manual')
        opt_est.aord = 2;
        opt_est.bord = 1;
        opt_est.n_in = opt_est.aord + opt_est.bord * length(opt_data.input);
        opt_est.n_node = 2 * opt_est.n_in;
    elseif strcmp(opt_est.choose_order,'automatic')
        opt_est = rn_order_estimation(data,opt_data,opt_est);
        opt_est = rn_node_estimation(data,opt_data,opt_est);
    end
end
    
opt_est.max_ord = max([opt_est.aord opt_est.bord]);
opt_est.eff_batch = opt_est.batch + opt_est.max_ord;
opt_est.n_input = length(opt_data.input);
