function [network err_old] = rn_choice(train_data,opt_data,opt_est)

assert(opt_est.repe >= 1);
assert(opt_est.train_est_perc > 0 && opt_est.train_est_perc < 1);

x = train_data(:,opt_data.input);
y = train_data(:,opt_data.output);
[n_sample n_input] = size(x);

a_ord = opt_est.aord;
b_ord = opt_est.bord;

%RN
init_train = max([a_ord b_ord]) + 1;
final_train = floor(n_sample * opt_est.train_est_perc);
init_test = final_train + 1;
final_test = n_sample;

y_train = y( init_train : final_train );
y_test  = y( init_test  : final_test  );

x_train = zeros(a_ord+b_ord*n_input,final_train - init_train + 1);
x_test  = zeros(a_ord+b_ord*n_input,final_test  - init_test  + 1);

for k = 1:a_ord
    x_train(k,:) = y((init_train - k):(final_train - k));
    x_test(k,:)  = y((init_test  - k):(final_test  - k));
end
for k = 1:b_ord
    x_train((a_ord+(k-1)*n_input+1):(a_ord+k*n_input),:) = x((init_train - k):(final_train - k),:)';
    x_test((a_ord+(k-1)*n_input+1):(a_ord+k*n_input),:)  = x((init_test  - k):(final_test  - k),:)';            
end


for i = 1:opt_est.repe
    temp_network = rn_init(opt_est);
    temp_network = rn_train(temp_network,x_train,y_train,opt_est);
    %fprintf('%s%i\n','Iteration: ',i);
    [temp_network y_pred] = rn_test(temp_network,x_test,opt_est);
    err_valid = NRMSE(y_pred,y_test);
    if i == 1
        err_old = err_valid;
        network = temp_network;
    elseif (i > 1 && err_valid < err_old)
        err_old = err_valid;
        network = temp_network;
    end
end
