function opt_est = rn_node_estimation(train_data,opt_est_data,opt_est)

assert(opt_est.train_est_perc > 0 && opt_est.train_est_perc < 1);

x = train_data(:,opt_est_data.input);
y = train_data(:,opt_est_data.output);
n_input = size(x,2);

%RN
max_nodes = opt_est.max_nodes;
min_nodes = 2 * opt_est.n_in;
err_valid = zeros(max_nodes-min_nodes+1,1);
init_train = max([opt_est.aord opt_est.bord]) + 1;
final_train = floor(length(y) * opt_est.train_est_perc);
init_test = final_train + 1;
final_test = length(y);

y_train = y( init_train : final_train );
y_test  = y( init_test  : final_test  );

x_train = zeros(opt_est.aord+opt_est.bord*n_input,final_train - init_train + 1);
x_test  = zeros(opt_est.aord+opt_est.bord*n_input,final_test  - init_test  + 1);

for k = 1:opt_est.aord
    x_train(k,:) = y((init_train - k):(final_train - k));
    x_test(k,:)  = y((init_test  - k):(final_test  - k));
end
for k = 1:opt_est.bord
    x_train((opt_est.aord+(k-1)*n_input+1):(opt_est.aord+k*n_input),:) = x((init_train - k):(final_train - k),:)';
    x_test((opt_est.aord+(k-1)*n_input+1):(opt_est.aord+k*n_input),:)  = x((init_test  - k):(final_test  - k),:)';            
end
opt_RN_ord = opt_est;

for n_node = min_nodes:max_nodes
    tic
    opt_RN_ord.n_node = n_node;

    network = rn_init(opt_RN_ord);
    network = rn_train(network,x_train,y_train,opt_RN_ord);
    [~, y_pred] = rn_test(network,x_test,opt_RN_ord);

    err_valid(n_node-min_nodes+1) = model_selection_computation(y_test,y_pred,n_node,opt_est);
    if opt_est.verbose == 1
        fprintf('%s%i%s\n','Analyzing network with ',n_node,' nodes');
    end
end

mini = find(err_valid == min(err_valid));
opt_est.n_node = mini(1) + min_nodes - 1;
if opt_est.verbose == 1
    fprintf('%s%i\n','Chosen Internal nodes: ',opt_est.n_node);
end

