function opt_est = rn_order_estimation(train_data,opt_data,opt_est)

assert(opt_est.train_est_perc > 0 && opt_est.train_est_perc < 1);

x = train_data(:,opt_data.input);
y = train_data(:,opt_data.output);
n_input = length(opt_data.input);

opt_RN_ord = opt_est;
opt_RN_ord.n_node = 4 * opt_est.max_ord_expl*(1+ n_input);

err_valid = zeros(opt_est.max_ord_expl,opt_est.max_ord_expl);
for a_ord = 1:opt_est.max_ord_expl
    for b_ord = 1:opt_est.max_ord_expl
        init_train = max([a_ord b_ord]) + 1;
        final_train = floor(opt_data.hor * opt_est.train_est_perc);
        init_test = final_train + 1;
        final_test = opt_data.hor;

        y_train = y( init_train : final_train );
        y_test  = y( init_test  : final_test  );

        x_train = zeros(a_ord+b_ord*n_input,final_train - init_train + 1);
        x_test  = zeros(a_ord+b_ord*n_input,final_test  - init_test  + 1);

        for k = 1:a_ord
            x_train(k,:) = y((init_train - k):(final_train - k));
            x_test(k,:)  = y((init_test  - k):(final_test  - k));
        end
        for k = 1:b_ord
            x_train((a_ord+(k-1)*n_input+1):(a_ord+k*n_input),:) = x((init_train - k):(final_train - k),:)';
            x_test((a_ord+(k-1)*n_input+1):(a_ord+k*n_input),:)  = x((init_test  - k):(final_test  - k),:)';            
        end
        
        opt_RN_ord.n_in = a_ord+b_ord*n_input;
        
        network = rn_init(opt_RN_ord);

        %%%% train the RN
        network = rn_train(network,x_train,y_train,opt_RN_ord);
        [~, y_pred] = rn_test(network,x_test,opt_RN_ord);
        err_valid(a_ord,b_ord) = model_selection_computation(y_pred,y_test,a_ord+b_ord*n_input,opt_RN_ord);
        if opt_est.verbose == 1
            fprintf('%s%i %i\n','Analyzing configuration ',a_ord,b_ord);
        end
    end
end
mini = find(err_valid == min(min(err_valid)));
[opt_est.aord opt_est.bord] = ind2sub(size(err_valid),mini(1));
opt_est.n_in = opt_est.aord + opt_est.bord * n_input;
if opt_est.verbose == 1
    fprintf('%s%i%s%i%s\n','Chosen orders: RN(',opt_est.aord,',',opt_est.bord,')');
end

